/*->h.geometry */


extern int insidebox(int x,int y,boxstr * box);
extern int nearlyinsidebox(int x,int y,int dx,int dy,boxstr * box);

extern void box2coord(coordstr * coord,boxstr * box);
extern void getmaxbox(boxstr * maxbox,boxstr * box,transformstr * tr);
extern void getmaxabox(aboxstr * maxbox,aboxstr * box,transformstr * tr);
extern int  getminbox2(boxstr * minbox,boxstr * box1,boxstr * box2);
extern int  boxoverlap(boxstr * box1,boxstr * box2);
extern int  boxinbox(boxstr * box1,boxstr * box2);
extern void getmaxinvabox(aboxstr * maxbox,aboxstr * box,transformstr * tr);
extern void abox2coord(coordstr * coord,aboxstr * box);

extern void box2abox(boxstr * box,aboxstr * abox);
extern void abox2box(aboxstr * abox,boxstr * box);

extern void getsumabox(aboxstr * maxbox,aboxstr * box);
extern void getsumbox(boxstr * maxbox,boxstr * box);

extern int  cmpbox(boxstr * b1,boxstr * b2);

extern int  getminabox(aboxstr * minbox,aboxstr * box1,aboxstr * box2);
extern void aboxshift(aboxstr * abox,int xshift,int yshift);






typedef struct boxbitstr
{
 int orgx;
 int orgy;
 int width;
 int height;
 int angle;
 int cx;
 int cy;
 int skew;
 int org2x;
 int org2y;
} boxbitstr;



extern void getboxbits(boxstr * box,transformstr * t,boxbitstr * boxbits);
extern void setboxtrans(boxbitstr * old,boxbitstr * xnew);
extern  int boxtrans(transformstr * r,transformstr * t,
                                    curvestr * c,transformstr * ct);

extern void getboxtransform(transformstr * tr,curvestr * c,int skew,int angle);
extern  int cmpboxbits(boxbitstr * b1,boxbitstr * b2);


extern int  splitboxes(boxstr * back,boxstr * front,boxstr * boxes);


