/*->h.find */


#define FMAXLEN 2048

typedef struct findstr
{
 int  xcase;
 int  whole;
 int  all;
 int  start;
 int  wild;
	int  zone;
 char s[FMAXLEN];
 char r[FMAXLEN];

} findstr;





extern vector find1;
extern vector find2;
extern int    findzone;

extern void wordstats(char * string,int * ucp,int * lcp,int * fucp);


extern os_error * clearfind(void);

extern os_error * saveinitfind1(vector * s);
extern os_error * saveinitfind3(vector * s0,vector * s1,vector * s2);
extern os_error * saveinitfind(vector * s);

extern os_error * setupfind(vector * s1,vector * s2);
extern os_error * setupfindo(vector * s1,int offset);

extern os_error * findreset(viewstr * view);


extern os_error * findstep(void);
extern os_error * findrestep(void);


extern os_error * validfindzone(vector * s,int * valid,
                                                   int soffset,int eoffset);
extern os_error * setfindzone(viewstr * view);

extern os_error * search(findstr * xfind,int * found,
                                         int * soffset,int * eoffset);


extern os_error * freplace(findstr * find);

extern os_error * globalreplace(findstr * find,int * sum);

extern int        checkfindzone(void);


extern os_error * unfinserts(filestr * file);
extern os_error * unfinsertf(filestr * file);


extern os_error * freplacesub(vector * v,int olen,int * nl,unsigned short * string,int * mod);
extern os_error * freplaceflow(vector * v,int olen,int * nlen,int backflow);


