/*->c.th     */


#include "stdafx.h"

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <ctype.h>
#include <time.h>

#include "os.h"
#include "wimp.h"
#include "sprite.h"
#include "font.h"
#include "bbc.h"
#include "flex.h"


#include "fsx.h"
#include "bf.h"
#include "scanplus.h"
#include "bits.h"
#include "transform.h"
#include "wos.h"
#include "poll.h"
#include "err.h"
#include "deb.h"
#include "etc.h"
#include "osddex.h"


#include "str.h"
#include "constants.h"
#include "reslink.h"


#include "obj.h"

#include "file.h"
#include "view.h"

#include "undo.h"

#include "codes.h"

#include "txstr.h"

#include "tx.h"
#include "vec.h"

#include "spell.h"
#include "spchk.h"

#include "find.h"

#include "act.h"


#include "th.h"


/****************************************************************************/










/* just given a word             */
/* replace word, and ack message */

static os_error * thsend(char * string,int * ack)
{
 vector  s;
 findstr find;

 if(checkfindzone())
 {
  *ack=1;

  s=act;

  memset(&find,0,sizeof(findstr));
  find.xcase=2;
  xzstrncpy(find.r,string,sizeof(find.r));

  return(freplace(&find));
 }

 return(NULL);
}




static os_error * thfindword(vector * s,char * string,int * eoffset)
{
 os_error * err;
 int        n;
 int        c;
 int        bits;
 int        offset;
 int        noffset;
 int        inword;


 *eoffset=-1;

 err=txlock(&s->textsrc,s->file);
 if(!err)
 {
  settosow(s);

  n=0;
  offset=s->textsrc.offset;
  inword=0;

  while(1)
  {
   c=*txptr(s->textsrc.sourcep,offset);
   bits=codex[c];
   noffset=offset+(bits & CODELEN);

   if(!inword) s->textsrc.offset=offset;

   if((c>64 && c<91) || (c>96 && c<123) || c>191) /* alpha character */
   {
    if(inword<31)
    {
     string[inword++]=(char)c;
    }
   }
   else
   if(c>47 && c<58 && inword) /* its a number after alpha */
   {
    if(inword<31)
    {
     string[inword++]=(char)c;
    }
   }
   else
   if((c=='\'' || c==145 || c=='-' || c==NBHYPH) && 
                         inword && followingalpha(s,noffset))
   {
    if(c==145) c='\'';
    if(c==NBHYPH) c='-';
    if(inword<31)
    {
     string[inword++]=(char)c;
    }
   }
   else
   if(c!=SNO && c!=DCHYPH)
   {
    if(inword)
    {
     *eoffset=offset;
     string[inword]=0;  /* look up word */
     break;
    }
    else
    if(c==EOT) break;
   } 

   offset=noffset;
  }

  txunlock(&s->textsrc,s->file);
 }

 return(err);
}




static ddech thchannel;

static os_error * ddeserver(ddech channel,int userhandle,int code,void * data,int size,char * item)
{
 int ack;

 cprintf("op server channel %x code %d",channel,code);

 switch(code)
 {
  case  OSDDE_DATA:
                    cprintf("dde data item %s data %s",item,data);
                   thsend((char*)data,&ack);
                   ddeclosechannel(thchannel);
                   thchannel=0;
                   break;

  case OSDDE_FINIT:
                   thchannel=0;
                   break;
 }


 return(NULL);

 USE(item);
 USE(size);
 USE(userhandle);
}





/* press key, check word */

os_error * thword(void)
{
 os_error * err;
 vector     s;
 vector     t;
 char       string[64];
 int        eoffset;
 int        valid;


 if(act.valid)
 {
  s=act;

  thfindword(&s,string,&eoffset);

  if(eoffset>0)
  {
   clearfind();
   saveinitfind1(&s);

   t=act;

   err=validfindzone(&t,&valid,s.textsrc.offset,eoffset);
   if(!err && valid)
   {
    err=undostart(act.file);
    if(!err)
    {
     setfindzone(menuview);
     undoend(act.file);
    }
   }

   if(!thchannel) ddeopenchannel(0,NULL,"dpthesaurus",
                  "<HKLM\\Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\DPThes.exe\\>",ddeserver,0,&thchannel);
   if(thchannel)  ddewritechannel(thchannel,string,strlen(string)+1,CF_TEXT,"lookup");
//   threceive(string);
  }
 }

 return(NULL);
}




os_error * thinit(void)
{
 os_error * err;

 err=NULL;


 return(err);
}

