/*->c.dbedcol */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>
#include <math.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "bbc.h"
#include "transform.h"
#include "xprocess.h"

#include "wos.h"

#include "err.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "colour.h"
#include "etc.h"
#include "bits.h"
#include "fsx.h"
#include "bf.h"
#include "redraw.h"


#include "dbhi.h"
#include "mhi.h"


#include "str.h"
#include "reslink.h"

#include "xxcolour.h"
#include "xcolour.h"
#include "colsep.h"

#include "dbcolour.h"
#include "dbpal.h"

#include "dbedcol.h"



static edcolfn   edcolclose;

static int       colourflags;
static int       edtype;

static int       edpal;

static filestr * edfile;



static modelstr initcolour;



// colour model -> RGB colour

static int edgetpal(int flags,modelstr * model,int pal)
{
 if(!(flags & 0x1))
 {
  if(model->no==CMYKMODEL)
  {
   pal=modelgetpal(NULL,edfile,model->no,&model->data.quad);
  }
 }

 return(pal);
}




// RGB colour -> colour model

static int edsetpal(int flags,int pal,modelstr * model)
{

 USE(flags);
 USE(pal);
 USE(model);

 return(0);
}





static os_error * edclose(modelstr * colour,int flags)
{
 os_error * err;

 err=NULL;

 if(flags & 0x1) colourflags|=COLOURTRANS;
 else            colourflags&=~COLOURTRANS;

 if(edcolclose) err=edcolclose(colour,colourflags);


 return(err);
}




os_error * edcol(filestr * file,modelstr * colour,int flags,edcolfn edcolx,dboxstr * parent)
{
 os_error * err;

 err=NULL;

 edcolclose=edcolx;
 colourflags=flags;
 edfile=file;

 colour->len=(colour->no==CMYKMODEL)?MOD4LEN:MOD3LEN;

 initcolour=*colour;

 err=openpal(edclose,edgetpal,edsetpal,(flags & COLOURTRANS)?0x1:0,colour,parent);

 return(err);
}

