/*->h.pict */


extern int pixfontbits;
extern int pixjpegbits;
extern int pixspritebits;



extern void unpackpicturedata(unpackedpicturedatastr * upd,pictboxstr * pictp);
extern void packpicturedata(pictboxstr * pictp,unpackedpicturedatastr * upd);

extern os_error * pictscaletofit(int pict,picturedatastr * pd,filestr * file);
extern os_error * pictcalctransform(int pict,filestr * file);
extern os_error * pictcalctransform2(int pict,filestr * file,
                                                          transformstr * trx);

extern os_error * pictupdatecontents(int pict,int section,filestr * file,
                                                 unpackedpicturedatastr * pd);


extern os_error * pictboxupdate(int pict,filestr * file,
                              unpackedpictdatastr * pd,pictchangebits * bits);

extern os_error * pictchanges(int pict,filestr * file,
                              unpackedpictdatastr * pd,pictchangebits * bits);



//extern os_error * pictprocess(int pict,filestr * file,pictprocstr * process);

extern os_error * pictinit(void);


extern os_error * pictcentre(int pict,filestr * file,picturedatastr * pdp,
                                                           coordstr * cx);

extern os_error * pictcentrepict(int pict,filestr * file,picturedatastr * pdp);

extern os_error * pictcheckcentre(int pict,filestr * file,
                                           picturedatastr * pdp);

extern os_error * pxdeletepicture(int pict,filestr * file);
extern os_error * pxdropcopypicture(objectloc * dloc,objectloc * sloc,
                                                  int otype,int * copied);
extern os_error * pxrefresh(int pict,int page,int section,filestr * file);

extern os_error * pxboundingcurves(pictboxstr ** pictpp,
                                                 filestr * file,int flags);

extern os_error * createpict1(objectloc * loc,curvestr * c,pictdatastr * data,
                              unpackedpicturedatastr * picturedata,
                              textflowstr *  flow,
                              transformstr * tr,int frame,
                              curvestr * ic,curvestr * oc,curvestr * pc);


extern os_error * pictloadsub(int ftype,int object,posnstr * posn);

extern os_error * pictdirectload(posnstr * posn,int picture,
                                                int * object,int * yshift);


extern os_error * transpict(pictboxstr * pictp,filestr * file,
                                      transformfn trf,int flags);

extern os_error * pxtxmakemaster(int text,int master,filestr * file);
extern os_error * pxmxsave(int pict,filestr * file);
extern os_error * pxmxload(int pict,filestr * file);
extern os_error * pxmxscrap(int pict,filestr * file);

extern os_error * pictfromtextlo(pictboxstr * pictp,filestr * file);

extern void pixsetup(int fp);

extern os_error * pictmerge(pictboxstr * pictp,int mergecommand,filestr * file);
extern os_error * pictmergeall(int command,int pass,filestr * file);

extern os_error * pictfontload(filestr * file,int * load,int flags);

extern os_error * pxlistfont(char * name,int userfont,void ** handle);



