



typedef struct ps_statestr
{
 int linewidth;
 int colourmodel;
 
 union
 {
  struct {
   double r;
   double g;
   double b;
  } rgb;

  struct {
   double c;
   double m;
   double y;
   double k;
 
  } cmyk;

 } foreground;

 int fxpts;
 int fypts;
 int font;
	int fontplane;
 transformstr ftr;
	int overprint;

} ps_statestr;



extern ps_statestr * ps_stackp;

extern os_error * ps_rgb(double r,double g,double b);

extern os_error * ps_push(void);
extern os_error * ps_pop(void);



extern os_error * ps_stackinit(void);


#define MAXFONTNAMELEN 256


#define PS_ENCSYMBOL (-1)
#define PS_ENCLATIN1 (-2)


extern int        pscharmapunicode(int userfont,int fontplane,int c);
extern int        pscharmapindex(int userfont,int * fontplane,int unicode);
extern os_error * pscharmapinfo(int userfont,int * fontplanes);
extern os_error * pscharmapfontinfo(int userfont,int fontplane,int * encodingtype);

extern os_error * pscodefontname(char * buffer,char * fontname,int fontplane,int max);



extern os_error * ps_uploadfont(char * name,int userfont);


extern os_error * ps_hexinit(void);
extern os_error * ps_hexwrite(int c);
extern os_error * ps_hexfinit(void);

extern os_error * ps_kerndata(int osfont,int userfont,int fontplane);




